//  


// wrench diameter plus some play
wdia = 3.2; // for 2.5mm
//wdia = 3.1; // for 2.4mm  3/32"
//wdia = 2.6; // for 2.0mm
//wdia = 2.0; // for 1.5mm
//wdia = 1.75; // for 1.25mm

// T handle dims for 2mm -2.5mm
outsidedia = 8; // diameter of the handle
crossheight = 17;
crosslength = 20;

// T handle dims for <2mm 
//outsidedia = 6; // diameter of the handle 
//crossheight = 15;
//crosslength = 17;

wrad = wdia/2;
outrad = outsidedia/2;
cutrad = wdia;


difference () {
	union () {
		
		// vertical shaft of T handle
		cylinder (h = crossheight+0.5, r = outrad, $fn = 30);

			
		translate ([0, 0, 9]) 
			
			difference () {
				
				translate ([outsidedia, 0, 0])
					rotate (a = [90, 0, 0])
					rotate_extrude (convexity = 10, $fn =30)
					translate ([outsidedia, 0, 0])
						circle (r = outrad, $fn = 30);
						
				translate ([15+outsidedia, 0, 0])
					cube (size = [30, 30, 30], center = true);
						
				translate ([0, 0, -15])
					cube (size = [30, 30, 30], center = true);
						
			} // difference

		rotate (a = [0, 0, 180])
			translate ([0, 0, 9]) 
			
				difference () {
				
					translate ([outsidedia, 0, 0])
						rotate (a = [90, 0, 0])
						rotate_extrude (convexity = 10, $fn =30)
						translate ([outsidedia, 0, 0])
							circle (r = outrad, $fn = 30);
						
					translate ([15+outsidedia, 0, 0])
						cube (size = [30, 30, 30], center = true);
						
					translate ([0, 0, -15])
						cube (size = [30, 30, 30], center = true);
					
				} // difference

		// crossbar of T handle
		translate ([-crosslength/2, 0, crossheight])
			rotate (a = [0, 90, 0])
				cylinder (h = crosslength, r = outrad, $fn = 30);

		// rounded ends of T
		translate ([-crosslength/2, 0, crossheight])
			sphere (r = outrad, center = true, $fn = 30);		
		translate ([crosslength/2, 0, crossheight])
			sphere (r = outrad, center = true, $fn = 30);				
				
		
		// rounded bottom
		sphere (r = outrad, center = true, $fn = 30);

	} // union 

	// slice it in half
	translate ([0, -50, 0])
		cube (size = 100, center = true);

	// cut out grove for the allen wrench
	translate ([0, 0, -(outrad+1)])
		cylinder (h =crossheight+outrad+1, r = wrad, $fn = 30);

	translate ([-wrad, 0, crossheight])
		rotate (a = [0, 90, 0])
			cylinder (h =crosslength+wrad+outrad+1, r = wrad, $fn = 30);
			
		
	difference () {
				
		translate ([cutrad, 0, crossheight-cutrad])
			rotate (a = [90, 0, 0])
			rotate_extrude (convexity = 10, $fn =30)
			translate ([cutrad, 0, 0])
				circle (r = wrad, $fn = 30);
						
		translate ([cutrad+15, 0, crossheight])
			cube (size = [30, 30, 30], center = true);
						
		translate ([0, 0, crossheight-cutrad-15])
			cube (size = [30, 30, 30], center = true);
						
	} // difference			
			
	difference () {
				
		translate ([2*cutrad, 0, crossheight-2*cutrad])
			rotate (a = [90, 0, 0])
			rotate_extrude (convexity = 10, $fn =30)
			translate ([2*cutrad, 0, 0])
				circle (r = wrad, $fn = 30);
						
		translate ([2*cutrad+15, 0, crossheight])
			cube (size = [30, 30, 30], center = true);
						
		translate ([0, 0, crossheight-2*cutrad-15])
			cube (size = [30, 30, 30], center = true);
						
	} // difference				
			
		difference () {
				
		translate ([3*cutrad, 0, crossheight-3*cutrad])
			rotate (a = [90, 0, 0])
			rotate_extrude (convexity = 10, $fn =30)
			translate ([3*cutrad, 0, 0])
				circle (r = wrad, $fn = 30);
						
		translate ([3*cutrad+15, 0, crossheight])
			cube (size = [30, 30, 30], center = true);
						
		translate ([0, 0, crossheight-3*cutrad-15])
			cube (size = [30, 30, 30], center = true);
						
	} // difference				


} // difference

translate ([crosslength*1.5, 0, 0])
difference () {
	union () {
		
		// vertical shaft of T handle
		cylinder (h = crossheight+0.5, r = outrad, $fn = 30);

			translate ([0, 0, 9]) 
			
				difference () {
				
					translate ([outsidedia, 0, 0])
						rotate (a = [90, 0, 0])
						rotate_extrude (convexity = 10, $fn =30)
						translate ([outsidedia, 0, 0])
							circle (r = outrad, $fn = 30);
						
					translate ([15+outsidedia, 0, 0])
						cube (size = [30, 30, 30], center = true);
						
					translate ([0, 0, -15])
						cube (size = [30, 30, 30], center = true);
						
				} // difference

		rotate (a = [0, 0, 180])
			translate ([0, 0, 9]) 
			
				difference () {
				
					translate ([outsidedia, 0, 0])
						rotate (a = [90, 0, 0])
						rotate_extrude (convexity = 10, $fn =30)
						translate ([outsidedia, 0, 0])
							circle (r = outrad, $fn = 30);
						
					translate ([15+outsidedia, 0, 0])
						cube (size = [30, 30, 30], center = true);
						
					translate ([0, 0, -15])
						cube (size = [30, 30, 30], center = true);
					
				} // difference

		translate ([-crosslength/2, 0, crossheight])
			rotate (a = [0, 90, 0])
				cylinder (h = crosslength, r = outrad, $fn = 30);

		
		// rounded ends of T
		translate ([-crosslength/2, 0, crossheight])
			sphere (r = outrad, center = true, $fn = 30);	
		translate ([crosslength/2, 0, crossheight])
			sphere (r = outrad, center = true, $fn = 30);
			
			
		sphere (r = outrad, center = true, $fn = 30);	

	} // union 

	// slice it in half
	translate ([0, -25, 20])
		cube (size = 50, center = true);

		
	// cut out grove for the allen wrench
	translate ([0, 0, -(outrad+1)])
		cylinder (h =crossheight+outrad+1, r = wrad, $fn = 30);

	translate ([wrad, 0, crossheight])
		rotate (a = [0, -90, 0])
			cylinder (h =crosslength+wrad+outrad+1, r = wrad, $fn = 30);
			

	difference () {
				
		translate ([-cutrad, 0, crossheight-cutrad])
			rotate (a = [90, 0, 0])
			rotate_extrude (convexity = 10, $fn =30)
			translate ([cutrad, 0, 0])
				circle (r = wrad, $fn = 30);
						
		translate ([-cutrad-15, 0, crossheight])
			cube (size = [30, 30, 30], center = true);
						
		translate ([0, 0, crossheight-cutrad-15])
			cube (size = [30, 30, 30], center = true);
						
	} // difference			
			
			
	difference () {
				
		translate ([-2*cutrad, 0, crossheight-2*cutrad])
			rotate (a = [90, 0, 0])
			rotate_extrude (convexity = 10, $fn =30)
			translate ([2*cutrad, 0, 0])
				circle (r = wrad, $fn = 30);
						
		translate ([-2*cutrad-15, 0, crossheight])
			cube (size = [30, 30, 30], center = true);
						
		translate ([0, 0, crossheight-2*cutrad-15])
			cube (size = [30, 30, 30], center = true);
						
	} // difference				
	
	
	difference () {
				
		translate ([-3*cutrad, 0, crossheight-3*cutrad])
			rotate (a = [90, 0, 0])
			rotate_extrude (convexity = 10, $fn =30)
			translate ([3*cutrad, 0, 0])
				circle (r = wrad, $fn = 30);
						
		translate ([-3*cutrad-15, 0, crossheight])
			cube (size = [30, 30, 30], center = true);
						
		translate ([0, 0, crossheight-3*cutrad-15])
			cube (size = [30, 30, 30], center = true);
						
	} // difference				


} // difference